## xrt 202210.2.13.466+dfsg

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2018-2022 Xilinx, Inc. All rights reserved.
#

PROJECT(XRT)
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.0)

ENABLE_TESTING()

SET(PROJECT_DESCRIPTION "https://github.com/Xilinx/XRT")

# Include supporting CMake functions
include(CMake/unitTestSupport.cmake)

# Exported interface into XRT for include from implemenation
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src
  ${CMAKE_CURRENT_SOURCE_DIR}/runtime_src/core/include
  ${CMAKE_BINARY_DIR}/gen
  )

if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif (NOT CMAKE_CXX_STANDARD)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

message("-- Host system processor is ${CMAKE_HOST_SYSTEM_PROCESSOR}")
message("-- Target system processor is ${CMAKE_SYSTEM_PROCESSOR}")

set(XRT_NATIVE_BUILD "yes")
if (NOT ${CMAKE_SYSTEM_PROCESSOR} STREQUAL ${CMAKE_HOST_SYSTEM_PROCESSOR})
  set(XRT_NATIVE_BUILD "no")
endif()

if ( ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang" )
  set(XRT_WARN_OPTS 
  -Wall -Werror
  -Wno-mismatched-tags 
  -Wno-unused-const-variable
  -Wno-unused-private-field 
  -Wno-missing-braces
  -Wno-self-assign
  -Wno-pessimizing-move 
  -Wno-unused-function 
  -Wno-unused-variable
  -Wno-parentheses     
  # These are dangerous and should be reviewed
  -Wno-overloaded-virtual
   )
else()
  set(XRT_WARN_OPTS -Wall -Werror )
endif()

if (DEFINED ENV{XRT_NATIVE_BUILD})
  set(XRT_NATIVE_BUILD $ENV{XRT_NATIVE_BUILD})
endif()

if (DEFINED ENV{XRT_CLANGTIDY_REVIEW})
  set(XRT_CLANGTIDY_REVIEW "yes")
  set(XRT_AIE_BUILD "yes")
  add_compile_options("-DXRT_ENABLE_AIE")
endif()

if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE RelWithDebInfo)
endif (NOT CMAKE_BUILD_TYPE)

set (CMAKE_INSTALL_PREFIX "/opt/xilinx")
if (${XRT_NATIVE_BUILD} STREQUAL "no")
  set (CMAKE_INSTALL_PREFIX "/usr")
endif()

# Enable AIE even on x86.  This is POC, once
# complete we will remove the need for these
# macros and defines.
if (${XRT_NATIVE_BUILD} STREQUAL "yes")
  set(XRT_AIE_BUILD "yes")
  set(XRT_ENABLE_AIE "yes")
  add_definitions (-DXRT_ENABLE_AIE -DXRT_AIE_BUILD)
endif()

# Default component name for any install() command without the COMPONENT argument
# The default component is the xrt run-time component, if XRT_DEV_COMPONENT is
# set to something different then a development component will be created with
# link libraries and header which are then excluded from runtime component
set (CMAKE_INSTALL_DEFAULT_COMPONENT_NAME "xrt")

# Enable development package by specifying development component name
# If XRT_DEV_COMPONENT is same DEFAULT_COMPONENT then only that package
# is created with both development and run-time content.
#set (XRT_DEV_COMPONENT "xrt-dev")
set (XRT_DEV_COMPONENT "xrt")

set (XRT_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

# Version adjusted to 2.11 after u30 branch creation
set(XRT_VERSION_RELEASE 202210)
SET(XRT_VERSION_MAJOR 2)
SET(XRT_VERSION_MINOR 13)

if (DEFINED ENV{XRT_VERSION_PATCH})
  SET(XRT_VERSION_PATCH $ENV{XRT_VERSION_PATCH})
else(DEFINED $ENV{XRT_VERSION_PATCH})
  SET(XRT_VERSION_PATCH 0)
endif(DEFINED ENV{XRT_VERSION_PATCH})

#set(XRT_SOVERSION ${XRT_VERSION_MAJOR}.${XRT_VERSION_MINOR})
set(XRT_SOVERSION ${XRT_VERSION_MAJOR})
set(XRT_VERSION_STRING ${XRT_VERSION_MAJOR}.${XRT_VERSION_MINOR}.${XRT_VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMake/")

if (${XRT_NATIVE_BUILD} STREQUAL "yes")
  # Temporary native wrapper while Linux code is being ported to windows.
  # When completed the two build flows will once again be merged into one
  # common file
  if (WIN32)
    include(CMake/nativeWin.cmake)
  else()
    include(CMake/nativeLnx.cmake)
  endif()
  include(CMake/nativeTests.cmake)
else()
  include(CMake/embedded_system.cmake)
endif()

=== tests/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Xilinx, Inc. All rights reserved.
#

CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
PROJECT(TESTS)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)

add_subdirectory(unit_test)
add_subdirectory(xrt)

=== src/python/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#

add_subdirectory(pybind11)

install(FILES xrt_binding.py    DESTINATION ${PY_INSTALL_DIR})
install(FILES ert_binding.py    DESTINATION ${PY_INSTALL_DIR})
install(FILES xclbin_binding.py DESTINATION ${PY_INSTALL_DIR})

=== src/runtime_src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#

# Note: Add Windows compilation directives at the END of this file

if( NOT WIN32)

if(${CMAKE_BUILD_TYPE} STREQUAL "Release" AND ${XRT_NATIVE_BUILD} STREQUAL "yes")
  add_subdirectory(doc)
endif()

option(XOCL_VERBOSE "Enable xocl verbosity" OFF)
option(XRT_VERBOSE "Enable xrt verbosity" OFF)

if (XOCL_VERBOSE)
  add_compile_options("-DXOCL_VERBOSE")
endif()

if(XRT_VERBOSE)
  add_compile_options("-DXRT_VERBOSE")
endif()

add_compile_options("-fPIC")

# TODO CL_TARGET_OPENCL_VERSION is not defined..
if (${XRT_NATIVE_BUILD} STREQUAL "yes")
  add_compile_options( ${XRT_WARN_OPTS} )
endif()
add_subdirectory(xdp)

add_subdirectory(tools/xclbinutil)
add_subdirectory(xocl)
add_subdirectory(xrt)
add_subdirectory(ert)
if (${XRT_NATIVE_BUILD} STREQUAL "yes")
  # Only for host native build.
  # For embedded, headers and libraries are installed in /usr
  # Not requeired setup.sh/.csh
  add_subdirectory(tools/scripts)
endif()

# Attach to the user's linker flags
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")

add_subdirectory(core)

else()
# = WINDOWS ===================================================================

  # Enable ALL warnings and make them errors if they occur
  if (MSVC)
    # warning level 4 and all warnings are errors
    add_compile_options(/WX /W4)
    if (DEFINED MSVC_PARALLEL_JOBS)
      string(CONCAT MP_OPTION "/MP" ${MSVC_PARALLEL_JOBS})
      add_compile_options(${MP_OPTION})
    endif()
  else()
    # lots of warnings and all warnings as errors
    # add_compile_options(-Wall -Wextra -pedantic -Werror)
    add_compile_options( ${XRT_WARN_OPTS} )
  endif()

  # Build Subdirectories
  if (NOT MCDM)
    add_subdirectory(xocl)
    add_subdirectory(xrt)
    add_subdirectory(tools/xclbinutil)
    add_subdirectory(xdp)
  endif (NOT MCDM)
  add_subdirectory(tools/scripts)
  add_subdirectory(core)
endif()

=== src/xma/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#
option(XMA_VERBOSE "Enable xma verbosity" OFF)

if (XMA_VERBOSE)
  add_compile_options("-DXMA_VERBOSE")
endif()

add_compile_options("-fPIC")
add_compile_options( ${XRT_WARN_OPTS} )
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")

add_subdirectory(src)

#Install all header files with directory structure
#Don't remove trailing/ in include/
install(DIRECTORY include/
  DESTINATION ${XMA_INSTALL_DIR}/include/xma2
  COMPONENT ${XRT_DEV_COMPONENT}
  PATTERN "include/lib" EXCLUDE
)

=== tests/message-mgmt/Makefile ===
CC    = g++
CFLAGS = -DDSA64 -g -std=c++11 mssg.cpp -I../../build/Debug/opt/xilinx/xrt/include
LDFLAGS = -L../../build/Debug/opt/xilinx/xrt/lib -lxrt_core -lpthread -lrt
run:
	@$(CC) $(CFLAGS) -o host.exe $(LDFLAGS)

clean:
	@find . -name '*.log' -delete
	@find . -name '*.exe' -delete
	@find ../ -name '*.log' -delete


%:
	@true

=== tests/unit_test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
PROJECT(UNIT_TEST)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(XILINX_XRT $ENV{XILINX_XRT})
set(XRT_CORE_LIBRARY xrt_core)

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

add_subdirectory(001_basic_sincos)
add_subdirectory(002_bitonic_sort)
add_subdirectory(003_bringup0)
add_subdirectory(004_bringup1)
add_subdirectory(005_bringup2)
add_subdirectory(006_copy)
add_subdirectory(007_copy_loop)
add_subdirectory(008_globalbandwidth)
add_subdirectory(009_mmult1)
add_subdirectory(010_mmult2)
add_subdirectory(011_mmult3)
add_subdirectory(012_mmult4)
add_subdirectory(013_montecarlo)
add_subdirectory(014_multikernel)
add_subdirectory(015_outoforderqueue)
add_subdirectory(016_parkernels)
add_subdirectory(017_vectorswizzle)
add_subdirectory(018_bringup3)
add_subdirectory(019_bringup4)
add_subdirectory(036_hello)
add_subdirectory(2kernelglobal_002_rw_4ddr_512)
add_subdirectory(cdma)
add_subdirectory(cuselect)
add_subdirectory(subdevice)
add_subdirectory(vadd_bank3)

=== tests/validate/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)

if (NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif (NOT CMAKE_CXX_STANDARD)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(MODE hw)

if (DEFINED ENV{XCL_EMULATION_MODE})
  set(MODE $ENV{XCL_EMULATION_MODE})
  string(REPLACE "_" "" XCL_EMU_SUFFIX ${MODE})
endif()

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

add_subdirectory(verify_test)
add_subdirectory(bandwidth_test)
add_subdirectory(hostmemory_test)

# Special iops performance test cases
add_subdirectory(xcl_iops_test)
add_subdirectory(xcl_vcu_test)
add_subdirectory(xrt_iops_test)

=== tests/xrt/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
PROJECT(XRT_TESTCASES)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(XILINX_XRT $ENV{XILINX_XRT})
set(XRT_CORE_LIBRARY xrt_core)

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

add_subdirectory(00_hello)
add_subdirectory(02_simple)
add_subdirectory(03_loopback)
add_subdirectory(04_swizzle)
add_subdirectory(07_sequence)
add_subdirectory(11_fp_mmult256)
add_subdirectory(13_add_one)
add_subdirectory(22_verify)
add_subdirectory(56_xclbin)
add_subdirectory(100_ert_ncu)
add_subdirectory(abort)
add_subdirectory(fa_kernel)
add_subdirectory(mailbox)
add_subdirectory(query)
add_subdirectory(perf_IOPS)
add_subdirectory(enqueue)
add_subdirectory(m2m_arg)
if (NOT WIN32)
  add_subdirectory(reset)
  add_subdirectory(102_multiproc_verify)
endif(NOT WIN32)

=== src/python/pybind11/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2020-2021 Xilinx, Inc. All rights reserved.
#

find_package(PythonLibs 3.4.0 REQUIRED)
if (PythonLibs_FOUND)
  message("-- Python libs version: ${PYTHONLIBS_VERSION_STRING}")
  message("-- PYTHON_INCLUDE_PATH ${PYTHON_INCLUDE_PATH}")
  string(REPLACE "." ";" PYTHONLIBS_VERSION_LIST ${PYTHONLIBS_VERSION_STRING})
  list(GET PYTHONLIBS_VERSION_LIST 0 PYTHONLIBS_VERSION_MAJOR)
  list(GET PYTHONLIBS_VERSION_LIST 1 PYTHONLIBS_VERSION_MINOR)

  if (${LINUX_FLAVOR} MATCHES "^(Ubuntu|Debian)")
    SET(PKGDIR "dist-packages")
  elseif (${LINUX_FLAVOR} MATCHES "^(RedHat|CentOS|Amazon|Fedora|SUSE)")
    SET(PKGDIR "site-packages")
  endif(${LINUX_FLAVOR} MATCHES "^(Ubuntu|Debian)")

  find_package(pybind11 2.6.0 REQUIRED PATHS "/usr/local/lib/python${PYTHONLIBS_VERSION_MAJOR}.${PYTHONLIBS_VERSION_MINOR}/${PKGDIR}/pybind11" "/usr/lib/python${PYTHONLIBS_VERSION_MAJOR}.${PYTHONLIBS_VERSION_MINOR}/${PKGDIR}/pybind11")
endif(PythonLibs_FOUND)

if (pybind11_FOUND)
  INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
  pybind11_add_module(pyxrt src/pyxrt.cpp)
  target_link_libraries(pyxrt PRIVATE xrt_coreutil uuid pthread)

  install(TARGETS pyxrt
    EXPORT xrt-targets
    LIBRARY DESTINATION ${PY_INSTALL_DIR} ${XRT_NAMELINK_SKIP}
    )

else(pybind11_FOUND)
  message(WARNING "-- pybind11 or python3 libs not found, pybind11 support disabled")
endif(pybind11_FOUND)

=== src/runtime_src/core/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

add_subdirectory(include)

if (${XRT_NATIVE_BUILD} STREQUAL "yes")
  add_subdirectory(common)
  add_subdirectory(pcie)
  if (NOT DEFINED MCDM)
    add_subdirectory(tools)
  endif()
else()
  add_subdirectory(common)
  add_subdirectory(edge)
  add_subdirectory(tools)
endif()

if (${XRT_CLANGTIDY_REVIEW})
  add_subdirectory(edge)
endif()

=== src/runtime_src/doc/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#
set(XRT_RUNTIME_SRC_DIR    "${CMAKE_CURRENT_SOURCE_DIR}/..")
set(XRT_DOC_TOC_DIR        "${CMAKE_CURRENT_SOURCE_DIR}/toc")
set(DOC_CORE_DIR           "${CMAKE_CURRENT_BINARY_DIR}/core")
set(DOC_TOC_DIR            "${CMAKE_CURRENT_BINARY_DIR}/toc")

file(GLOB XRT_MGMT_IOCTL_H ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/include/mgmt-ioctl.h)
file(GLOB XRT_XOCL_IOCTL_H ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/include/xocl_ioctl.h)
file(GLOB XRT_ZOCL_IOCTL_H ${XRT_RUNTIME_SRC_DIR}/core/edge/include/zynq_ioctl.h)
file(GLOB XRT_BO_H         ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_bo.h)
file(GLOB XRT_DEVICE_H     ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_device.h)
file(GLOB XRT_IP_H         ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_ip.h)
file(GLOB XRT_KERNEL_H     ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_kernel.h)
file(GLOB XRT_MAILBOX_H    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_mailbox.h)
file(GLOB XRT_MESSAGE_H    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_message.h)
#file(GLOB XRT_QUEUE_H      ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_queue.h)
file(GLOB XRT_SYSTEM_H     ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_system.h)
file(GLOB XRT_UUID_H       ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_uuid.h)
file(GLOB XRT_XCLBIN_H     ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_xclbin.h)
file(GLOB XRT_INI_H        ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_ini.h)
file(GLOB XRT_XRT_H        ${XRT_RUNTIME_SRC_DIR}/core/include/xrt.h)
file(GLOB XRT_ERT_H        ${XRT_RUNTIME_SRC_DIR}/core/include/ert.h)
file(GLOB XRT_XMA_H        ${XRT_RUNTIME_SRC_DIR}/../xma/include/xma.h)
file(GLOB XRT_XMA_PLUGIN_H ${XRT_RUNTIME_SRC_DIR}/../xma/include/xmaplugin.h)
file(GLOB XRT_XMA_ENCODER_H ${XRT_RUNTIME_SRC_DIR}/../xma/include/app/xmaencoder.h)
file(GLOB XRT_XMA_DECODER_H ${XRT_RUNTIME_SRC_DIR}/../xma/include/app/xmadecoder.h)
file(GLOB XRT_XMA_FILTER_H ${XRT_RUNTIME_SRC_DIR}/../xma/include/app/xmafilter.h)
file(GLOB XRT_XMA_SCALER_H ${XRT_RUNTIME_SRC_DIR}/../xma/include/app/xmascaler.h)
file(GLOB XRT_XMA_KERNEL_H ${XRT_RUNTIME_SRC_DIR}/../xma/include/app/xmakernel.h)
file(GLOB XRT_MAILBOX_PROTO_H ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/include/mailbox_proto.h)
file(GLOB XRT_MAILBOX_C    ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/xocl/subdev/mailbox.c)

file(MAKE_DIRECTORY ${DOC_CORE_DIR})
file(COPY ${XRT_DOC_TOC_DIR} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

set(KERNELDOC "kernel-doc")
set(KERNELDOC_URL "https://git.kernel.org/pub/scm/linux/kernel/git/stable/linux-stable.git/plain/scripts/kernel-doc?h=v4.14.52")

if (NOT EXISTS ${CMAKE_BINARY_DIR}/${KERNELDOC})
  MESSAGE(STATUS "${KERNELDOC} downloading")
  file(DOWNLOAD ${KERNELDOC_URL} "./${KERNELDOC}")
  execute_process(COMMAND chmod +x ${KERNELDOC})
endif ()

find_program(KERNELDOC_EXECUTABLE ${KERNELDOC} PATHS ${CMAKE_BINARY_DIR})
find_program(SPHINX_EXECUTABLE sphinx-build)
find_program(DOXYGEN_EXECUTABLE doxygen)

if (NOT DOXYGEN_EXECUTABLE)
  message(WARNING "doxygen not found, XRT C++ documentation is disabled")
  add_custom_target(
    doxygen
    )
else()
  set(XRT_CPP_APIS
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_device.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_bo.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_kernel.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_uuid.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_ini.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_mailbox.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_message.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_ip.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_system.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_xclbin.h
    )
  string(REPLACE ";" " " DOXY_INPUT "${XRT_CPP_APIS}")
  set(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
  add_custom_target(
    doxygen
    DEPENDS ${XRT_CPP_APIS}
    COMMAND ${DOXYGEN_EXECUTABLE} -g ${DOXYFILE}
    COMMAND echo "PROJECT_NAME = XRT" >> ${DOXYFILE}
    COMMAND echo "GENERATE_XML = YES" >> ${DOXYFILE}
    COMMAND echo "MACRO_EXPANSION = YES" >> ${DOXYFILE}
    COMMAND echo "EXTRACT_ALL = YES" >> ${DOXYFILE}
    COMMAND echo "SHOW_NAMESPACES = YES" >> ${DOXYFILE}
    COMMAND echo "PREDEFINED = __cplusplus XCL_DRIVER_DLLESPEC=" >> ${DOXYFILE}
    COMMAND echo "EXPAND_AS_DEFINED = XCL_DRIVER_DLLESPEC" >> ${DOXYFILE}
    COMMAND echo "IMAGE_PATH = ${XRT_DOC_TOC_DIR}" >> ${DOXYFILE}
    COMMAND echo "INPUT = ${DOXY_INPUT}" >> ${DOXYFILE}
    COMMAND ${DOXYGEN_EXECUTABLE}
    )
endif(NOT DOXYGEN_EXECUTABLE)

if (NOT KERNELDOC_EXECUTABLE OR NOT SPHINX_EXECUTABLE)
  MESSAGE (WARNING "kernel-doc or Sphinx not found, XRT documentation build disabled")
else ()
  add_custom_command(OUTPUT core/mgmt-ioctl.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MGMT_IOCTL_H} > core/mgmt-ioctl.rst
    DEPENDS ${XRT_MGMT_IOCTL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xocl_ioctl.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XOCL_IOCTL_H} > core/xocl_ioctl.rst
    DEPENDS ${XRT_XOCL_IOCTL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/zocl_ioctl.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_ZOCL_IOCTL_H} > core/zocl_ioctl.rst
    DEPENDS ${XRT_ZOCL_IOCTL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_bo.rst
    DEPENDS ${XRT_BO_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_BO_H} > core/xrt_bo.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_device.rst
    DEPENDS ${XRT_DEVICE_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_DEVICE_H} > core/xrt_device.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_ini.rst
    DEPENDS ${XRT_INI_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_INI_H} > core/xrt_ini.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_ip.rst
    DEPENDS ${XRT_IP_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_IP_H} > core/xrt_ip.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_kernel.rst
    DEPENDS ${XRT_KERNEL_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_KERNEL_H} > core/xrt_kernel.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_message.rst
    DEPENDS ${XRT_MESSAGE_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MESSAGE_H} > core/xrt_message.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_system.rst
    DEPENDS ${XRT_SYSTEM_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_SYSTEM_H} > core/xrt_system.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_uuid.rst
    DEPENDS ${XRT_UUID_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_UUID_H} > core/xrt_uuid.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_xclbin.rst
    DEPENDS ${XRT_XCLBIN_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XCLBIN_H} > core/xrt_xclbin.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XRT_H} > core/xrt.rst
    DEPENDS ${XRT_XRT_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/ert.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_ERT_H} > core/ert.rst
    DEPENDS ${XRT_ERT_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xma.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_H} > core/xma.rst
    DEPENDS ${XRT_XMA_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xmaplugin.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_PLUGIN_H} > core/xmaplugin.rst
    DEPENDS ${XRT_XMA_PLUGIN_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xmaencoder.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_ENCODER_H} > core/xmaencoder.rst
    DEPENDS ${XRT_XMA_ENCODER_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xmadecoder.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_DECODER_H} > core/xmadecoder.rst
    DEPENDS ${XRT_XMA_DECODER_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xmascaler.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_SCALER_H} > core/xmascaler.rst
    DEPENDS ${XRT_XMA_SCALER_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xmakernel.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_KERNEL_H} > core/xmakernel.rst
    DEPENDS ${XRT_XMA_KERNEL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xmafilter.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XMA_FILTER_H} > core/xmafilter.rst
    DEPENDS ${XRT_XMA_FILTER_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/mailbox_proto.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MAILBOX_PROTO_H} > core/mailbox_proto.rst
    DEPENDS ${XRT_MAILBOX_PROTO_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/mailbox.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MAILBOX_C} > core/mailbox.rst
    DEPENDS ${XRT_MAILBOX_C}
    VERBATIM
    )


  add_custom_target(
    xrt_docs
    DEPENDS
    doxygen
    core/mgmt-ioctl.rst
    core/xocl_ioctl.rst
    core/zocl_ioctl.rst
    core/xrt_bo.rst
    core/xrt_device.rst
    core/xrt_ini.rst
    core/xrt_ip.rst
    core/xrt_kernel.rst
    core/xrt_message.rst
    core/xrt_system.rst
    core/xrt_uuid.rst
    core/xrt_xclbin.rst
    core/xrt.rst
    core/ert.rst
    core/xma.rst
    core/xmaplugin.rst
    core/xmaencoder.rst
    core/xmadecoder.rst
    core/xmascaler.rst
    core/xmafilter.rst
    core/xmakernel.rst
    core/mailbox_proto.rst
    core/mailbox.rst
    COMMENT "Generating documentation with Sphinx"
    COMMAND ${CMAKE_COMMAND} -E make_directory  html
    COMMAND rm -rf ${DOC_TOC_DIR}/*
    COMMAND cp -rf ${XRT_DOC_TOC_DIR}/* ${DOC_TOC_DIR}
    COMMAND ${SPHINX_EXECUTABLE} -a ${DOC_TOC_DIR} html
    )
endif ()

# Don't forget to add a rst file under toc/ for html generation

=== debian/control ===
Source: xrt
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
	   Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: cmake,
	debhelper-compat (= 13),
	doxygen [amd64],
	libboost-filesystem-dev,
	libboost-program-options-dev,
	libboost-system-dev,
	libcurl4-openssl-dev,
	libdrm-dev,
	libncurses-dev,
	libprotobuf-dev,
	libssl-dev,
	libudev-dev,
	libyaml-dev,
	lsb-release [amd64],
	ocl-icd-opencl-dev,
	ocl-icd-dev,
	pkg-config,
	protobuf-compiler,
	uuid-dev,
	rapidjson-dev,
	pybind11-dev,
	dh-dkms <!pkg.xrt.bpo>,
	dh-exec,
	libffi-dev,
	python3-all-dev
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Homepage: https://www.xilinx.com/products/design-tools/vitis/xrt.html
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/xrt.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/xrt

Package: libxrt1
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for xrt.

Package: libxrt-dev
Architecture: arm64 amd64
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libxrt1 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - development files
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the development environment for xrt.

Package: libxrt-utils
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, libxrt1 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the xrt project.

# Package: zocl-edge-dkms
# Section: kernel
# Architecture: arm64
# Depends: ${misc:Depends},
#          ${shlibs:Depends},
#          dkms
# Description: Xilinx Runtime (XRT) - ZOCL DKMS kernel drivers for Edge
#  Xilinx Runtime library (XRT) is an open-source easy to
#  use software stack that facilitates management and usage of
#  field-programmable gate array (FPGA) / Adaptive Compute Acceleration
#  Platform (ACAP) devices. Users use familiar programming languages
#  like C/C++ or Python to write host code which uses XRT to interact
#  with FPGA/ACAP device. XRT exports well defined set of software APIs
#  that work across PCIe based datacenter platforms and ZYNQ UltraScale+
#  MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
#  userspace and kernel driver components.
#  .
#  This package contains the ZOCL DKMS kernel drivers for Edge.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic

export DEB_CXXFLAGS_MAINT_APPEND +=-Wno-error=unused-but-set-variable \
		  -Wno-error=unused-variable \
		  -Wno-error=sign-compare \
		  -Wno-error=reorder \
		  -Wno-error=deprecated-declarations \
		  -Wno-stringop-overflow \
		  -Wno-error=maybe-uninitialized \
		  -Wno-error=overloaded-virtual \
		  -Wno-error=mismatched-new-delete

BUILDDIR := obj-$(DEB_HOST_GNU_TYPE)

BUILD_DKMS ?= false

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Debug \
	-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

DH_OPTION =
ifeq ($(DEB_HOST_ARCH),arm64)
CONFIGURE_ARGS += -DXRT_EDGE_BUILD=yes
ifeq ($(BUILD_DKMS),true)
DH_OPTION = --with dkms
endif
endif

%:
	dh $@ $(DH_OPTION)

override_dh_auto_configure:
	dh_auto_configure --sourcedir=src -- $(CONFIGURE_ARGS)

override_dh_auto_build:
ifeq ($(DEB_HOST_ARCH) $(BUILD_DKMS), arm64 true)
	sed -i 's/^# //' debian/control
endif

	dh_auto_build --sourcedir=src

override_dh_auto_install:
	dh_auto_install --sourcedir=src

	cd $(CURDIR)/debian/tmp/usr/lib/$(DEB_BUILD_MULTIARCH)/; \
	mv libxilinxopencl_static.a libxilinxopencl.a; \
	mv libxrt++_static.a libxrt++.a; \
	mv libxrt_core_static.a libxrt_core.a; \
	mv libxrt_coreutil_static.a libxrt_coreutil.a

ifeq ($(DEB_HOST_ARCH),amd64)
	cd $(CURDIR)/debian/tmp/usr/lib/$(DEB_BUILD_MULTIARCH)/; \
	mv libxrt_hwemu_static.a libxrt_hwemu.a; \
	mv libxrt_swemu_static.a libxrt_swemu.a 
endif

ifeq ($(DEB_HOST_ARCH) $(BUILD_DKMS), arm64 true)
	dh_install -p zocl-edge-dkms -Xpcie -Xtools -XCMakeLists.txt \
		src/runtime_src/core/* usr/src/zocl-edge-$(DEB_VERSION_UPSTREAM)/
endif

	rm -rf $(CURDIR)/debian/tmp/usr/bin/unwrapped/
	rm -rf $(CURDIR)/debian/tmp/usr/src

	# Fix lintian: script-with-language-extension
ifeq ($(DEB_HOST_ARCH),amd64)
	mv $(CURDIR)/debian/tmp/usr/bin/plp_program.sh \
		$(CURDIR)/debian/tmp/usr/bin/plp_program
	mv $(CURDIR)/debian/tmp/usr/bin/mpd \
		$(CURDIR)/debian/tmp/usr/bin/xrt_mpd
endif

override_dh_missing:

override_dh_auto_test:
	-dh_auto_test

override_dh_dkms:
ifeq ($(DEB_HOST_ARCH) $(BUILD_DKMS), arm64 true)
	dh_dkms -p zocl-edge-dkms -V $(DEB_VERSION_UPSTREAM)
endif

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/Vitis-AI-$1.tar.gz/,dversionmangle=s/\+dfsg// \
       https://github.com/Xilinx/XRT/tags .*/v?(\d\S*)\.tar\.gz
